
#include "stdafx.h"
#include "RacialGenerator.h"
#include "dice.h"
#include <time.h>
#include <stdlib.h>
#include <string>

using namespace std;

Race* myRace;
int Seed;

string hey;


Race::Race()
    {
    basicType = racialOrigins = kinshipStructure = kinshipStructureExtension = -1;
    values = politicalStructure = politicalStructureExtension = language = -1;
    worship = worshipExtension = xenoAcceptance = problems = problemsExtension = -1;
    scienceLevel.compEng.diffLevel = scienceLevel.compEng.miscMod = scienceLevel.compEng.rankBonus = -1;
    scienceLevel.elecEng.diffLevel = scienceLevel.elecEng.miscMod = scienceLevel.elecEng.rankBonus = -1;
    scienceLevel.mechEng.diffLevel = scienceLevel.mechEng.miscMod = scienceLevel.mechEng.rankBonus = -1;
    scienceLevel.powrEng.diffLevel = scienceLevel.powrEng.miscMod = scienceLevel.powrEng.rankBonus = -1;
    scienceLevel.weapEng.diffLevel = scienceLevel.weapEng.miscMod = scienceLevel.weapEng.rankBonus = -1;
    }

Race::~Race()
    {

    }

int Race::generate(int location, int lightYears, int other)
    {
    modifiers mod, originsMods, valuesMods;
    int lightYearsFromSol = lightYears;
    // Location is 0 = Inner Province so mod = -50
    //             1 = Frontier so mod = -5
    //             2 = Backnet so mod = OE
    switch(location){
        case 0:
            mod.modifier = -50;
            mod.openEnded = false;
            break;
        case 1:
            mod.modifier = -5;
            mod.openEnded = false;
            break;
        case 2:
            mod.modifier = 0;
            mod.openEnded = true;
            break;
        }

    mod = basicTypeFind(mod);
    mod.modifier += -50;
    mod.modifier += lightYearsFromSol;
    mod = racialOriginsFind(mod);
    originsMods = mod;
    mod = kinshipStructureFind(mod);
    mod = valuesFind(mod);
    valuesMods = mod;
    mod = politicalStructureFind(mod);
    mod = scienceLevelFind(mod);
    mod = originsMods;
    mod.modifier += -50;
    mod.modifier += lightYearsFromSol;
    mod = languageFind(mod);
    mod = originsMods;
    mod = worshipFind(mod);
    mod = valuesMods;
    mod = xenoAcceptanceFind(mod);
    mod = valuesMods;
    mod = problemsFind(mod);
    return 0;
    }



int Race::generate()
    {
    modifiers mod, originsMods, valuesMods;
    int lightYearsFromSol = 50;

    mod.modifier = -50;
    mod.openEnded = false;
    mod = basicTypeFind(mod);
    mod.modifier += -50;
    mod.modifier += lightYearsFromSol;
    mod = racialOriginsFind(mod);
    originsMods = mod;
    mod = kinshipStructureFind(mod);
    mod = valuesFind(mod);
    valuesMods = mod;
    mod = politicalStructureFind(mod);
    mod = scienceLevelFind(mod);
    mod = originsMods;
    mod.modifier += -50;
    mod.modifier += lightYearsFromSol;
    mod = languageFind(mod);
    mod = originsMods;
    mod = worshipFind(mod);
    mod = valuesMods;
    mod = xenoAcceptanceFind(mod);
    mod = valuesMods;
    mod = problemsFind(mod);
    return 0;
    }

modifiers Race::basicTypeFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->basicType = 0;
        nextModifier.modifier = -15;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->basicType = 1;
        nextModifier.modifier = -10;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->basicType = 2;
        nextModifier.modifier = 80;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->basicType = 3;
        nextModifier.modifier = -10;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->basicType = 4;
        nextModifier.modifier = -8;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->basicType = 5;
        nextModifier.modifier = -10;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->basicType = 6;
        nextModifier.modifier = 60;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->basicType = 7;
        nextModifier.modifier = 80;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->basicType = 8;
        nextModifier.modifier = 80;
        nextModifier.openEnded = false;
        }
    else
        {
        this->basicType = 9;
        nextModifier.modifier = 80;
        nextModifier.openEnded = false;
        }

    return nextModifier;
    }

modifiers Race::racialOriginsFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->racialOrigins = 0;
        nextModifier.modifier = -8;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->racialOrigins = 1;
        nextModifier.modifier = -5;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->racialOrigins = 2;
        nextModifier.modifier = -2;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->racialOrigins = 3;
        nextModifier.modifier = -1;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->racialOrigins = 4;
        nextModifier.modifier = -2;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->racialOrigins = 5;
        nextModifier.modifier = -5;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->racialOrigins = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 100)
        {
        this->racialOrigins = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 110)
        {
        this->racialOrigins = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else
        {
        this->racialOrigins = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }

    return nextModifier;
    }

modifiers Race::kinshipStructureFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->kinshipStructure = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 30)
        {
        this->kinshipStructure = 1;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 60)
        {
        this->kinshipStructure = 2;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 70)
        {
        this->kinshipStructure = 3;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 75)
        {
        this->kinshipStructure = 4;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 80)
        {
        this->kinshipStructure = 5;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 90)
        {
        this->kinshipStructure = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 100)
        {
        this->kinshipStructure = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 110)
        {
        this->kinshipStructure = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else
        {
        this->kinshipStructure = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }

    this->kinshipStructureExtension =  randomDie(10,1);

    return nextModifier;
    }

modifiers Race::valuesFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->values = 0;
        nextModifier.modifier = -20;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 30)
        {
        this->values = 1;
        nextModifier.modifier = -10;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 60)
        {
        this->values = 2;
        nextModifier.modifier = -5;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 70)
        {
        this->values = 3;
        nextModifier.modifier = 5;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 75)
        {
        this->values = 4;
        nextModifier.modifier = 10;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 80)
        {
        this->values = 5;
        nextModifier.modifier = 20;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 90)
        {
        this->values = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 100)
        {
        this->values = 7;
        nextModifier.modifier = 10;
        nextModifier.openEnded = true;
        }
    else if(random + mods.modifier <= 110)
        {
        this->values = 8;
        nextModifier.modifier = 30;
        nextModifier.openEnded = true;
        }
    else
        {
        this->values = 9;
        nextModifier.modifier = randomDieOpenEnded(0);
        nextModifier.openEnded = true;
        }


    return nextModifier;
    }

modifiers Race::politicalStructureFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->politicalStructure = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->politicalStructure = 1;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->politicalStructure = 2;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->politicalStructure = 3;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->politicalStructure = 4;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->politicalStructure = 5;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->politicalStructure = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->politicalStructure = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->politicalStructure = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->politicalStructure = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    this->politicalStructureExtension =  randomDie(10,1);

    return nextModifier;
    }

modifiers Race::scienceLevelFind(modifiers mods){
    modifiers nextModifier;
    int random;
    // compEng
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->scienceLevel.compEng.diffLevel = 0;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = 30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->scienceLevel.compEng.diffLevel = 0;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->scienceLevel.compEng.diffLevel = 0;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = -20;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->scienceLevel.compEng.diffLevel = 0;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->scienceLevel.compEng.diffLevel = 1;
        this->scienceLevel.compEng.rankBonus = 4;
        this->scienceLevel.compEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->scienceLevel.compEng.diffLevel = 1;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->scienceLevel.compEng.diffLevel = 1;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = -50;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->scienceLevel.compEng.diffLevel = 2;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = -10;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->scienceLevel.compEng.diffLevel = 3;
        this->scienceLevel.compEng.rankBonus = 4;
        this->scienceLevel.compEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->scienceLevel.compEng.diffLevel = 4;
        this->scienceLevel.compEng.rankBonus = 5;
        this->scienceLevel.compEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    //elecEng
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->scienceLevel.elecEng.diffLevel = 0;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = 30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->scienceLevel.elecEng.diffLevel = 0;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->scienceLevel.elecEng.diffLevel = 0;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = -20;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->scienceLevel.elecEng.diffLevel = 0;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->scienceLevel.elecEng.diffLevel = 1;
        this->scienceLevel.elecEng.rankBonus = 4;
        this->scienceLevel.elecEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->scienceLevel.elecEng.diffLevel = 1;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->scienceLevel.elecEng.diffLevel = 1;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = -50;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->scienceLevel.elecEng.diffLevel = 2;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = -10;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->scienceLevel.elecEng.diffLevel = 3;
        this->scienceLevel.elecEng.rankBonus = 4;
        this->scienceLevel.elecEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->scienceLevel.elecEng.diffLevel = 4;
        this->scienceLevel.elecEng.rankBonus = 5;
        this->scienceLevel.elecEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    //mechEng
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->scienceLevel.mechEng.diffLevel = 0;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = 30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->scienceLevel.mechEng.diffLevel = 0;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->scienceLevel.mechEng.diffLevel = 0;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = -20;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->scienceLevel.mechEng.diffLevel = 0;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->scienceLevel.mechEng.diffLevel = 1;
        this->scienceLevel.mechEng.rankBonus = 4;
        this->scienceLevel.mechEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->scienceLevel.mechEng.diffLevel = 1;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->scienceLevel.mechEng.diffLevel = 1;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = -50;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->scienceLevel.mechEng.diffLevel = 2;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = -10;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->scienceLevel.mechEng.diffLevel = 3;
        this->scienceLevel.mechEng.rankBonus = 4;
        this->scienceLevel.mechEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->scienceLevel.mechEng.diffLevel = 4;
        this->scienceLevel.mechEng.rankBonus = 5;
        this->scienceLevel.mechEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    //powrEng
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->scienceLevel.powrEng.diffLevel = 0;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = 30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->scienceLevel.powrEng.diffLevel = 0;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->scienceLevel.powrEng.diffLevel = 0;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = -20;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->scienceLevel.powrEng.diffLevel = 0;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->scienceLevel.powrEng.diffLevel = 1;
        this->scienceLevel.powrEng.rankBonus = 4;
        this->scienceLevel.powrEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->scienceLevel.powrEng.diffLevel = 1;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->scienceLevel.powrEng.diffLevel = 1;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = -50;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->scienceLevel.powrEng.diffLevel = 2;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = -10;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->scienceLevel.powrEng.diffLevel = 3;
        this->scienceLevel.powrEng.rankBonus = 4;
        this->scienceLevel.powrEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->scienceLevel.powrEng.diffLevel = 4;
        this->scienceLevel.powrEng.rankBonus = 5;
        this->scienceLevel.powrEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    //weapEng
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->scienceLevel.weapEng.diffLevel = 0;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = 30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->scienceLevel.weapEng.diffLevel = 0;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->scienceLevel.weapEng.diffLevel = 0;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = -20;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->scienceLevel.weapEng.diffLevel = 0;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->scienceLevel.weapEng.diffLevel = 1;
        this->scienceLevel.weapEng.rankBonus = 4;
        this->scienceLevel.weapEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->scienceLevel.weapEng.diffLevel = 1;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->scienceLevel.weapEng.diffLevel = 1;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = -50;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->scienceLevel.weapEng.diffLevel = 2;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = -10;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->scienceLevel.weapEng.diffLevel = 3;
        this->scienceLevel.weapEng.rankBonus = 4;
        this->scienceLevel.weapEng.miscMod = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->scienceLevel.weapEng.diffLevel = 4;
        this->scienceLevel.weapEng.rankBonus = 5;
        this->scienceLevel.weapEng.miscMod = -30;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    nextModifier.modifier += (-50);

    return nextModifier;
    }

modifiers Race::languageFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->language = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->language = 1;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->language = 2;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->language = 3;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->language = 4;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->language = 5;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->language = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->language = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->language = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->language = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    return nextModifier;
    }

modifiers Race::worshipFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->worship = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->worship = 1;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->worship = 2;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->worship = 3;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->worship = 4;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->worship = 5;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->worship = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->worship = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->worship = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->worship = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    this->worshipExtension = randomDie(10,1);

    return nextModifier;
    }

modifiers Race::xenoAcceptanceFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->xenoAcceptance = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->xenoAcceptance = 1;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->xenoAcceptance = 2;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->xenoAcceptance = 3;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->xenoAcceptance = 4;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->xenoAcceptance = 5;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->xenoAcceptance = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->xenoAcceptance = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->xenoAcceptance = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->xenoAcceptance = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    return nextModifier;
    }

modifiers Race::problemsFind(modifiers mods){
    modifiers nextModifier;
    int random;
    if(mods.openEnded)
        {
        random = randomDieOpenEnded(0);
        }
    else
        {
        random = randomDie(100, 1);
        }

    if(random + mods.modifier <= 0)
        {
        this->problems = 0;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 30)
        {
        this->problems = 1;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 60)
        {
        this->problems = 2;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 70)
        {
        this->problems = 3;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 75)
        {
        this->problems = 4;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 80)
        {
        this->problems = 5;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 90)
        {
        this->problems = 6;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 100)
        {
        this->problems = 7;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else if(random + mods.modifier <= 110)
        {
        this->problems = 8;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }
    else
        {
        this->problems = 9;
        nextModifier.modifier = 0;
        nextModifier.openEnded = false;
        }

    this->problemsExtension = randomDie(10,1);

    return nextModifier;
    }

int Race::printRace()
    {
    printf("basicType = %i\n", basicType);
    printf("racialOrigins = %i\n", racialOrigins);
    printf("kinshipStructure = %i\n", kinshipStructure);
    printf("kinshipStructureExtension = %i\n", kinshipStructureExtension);
    printf("values = %i\n", values);
    printf("politicalStructure = %i\n", politicalStructure);
    printf("politicalStructureExtension = %i\n", politicalStructureExtension);
    printf("ScienceLevels\n");
    printf("compEng\n");
    printf("   diffLevel = %i\n", scienceLevel.compEng.diffLevel);
    printf("   rankBonus = %i\n", scienceLevel.compEng.rankBonus);
    printf("   miscMod = %i\n", scienceLevel.compEng.miscMod);
    printf("elecEng\n");
    printf("   diffLevel = %i\n", scienceLevel.elecEng.diffLevel);
    printf("   rankBonus = %i\n", scienceLevel.elecEng.rankBonus);
    printf("   miscMod = %i\n", scienceLevel.elecEng.miscMod);
    printf("mechEng\n");
    printf("   diffLevel = %i\n", scienceLevel.mechEng.diffLevel);
    printf("   rankBonus = %i\n", scienceLevel.mechEng.rankBonus);
    printf("   miscMod = %i\n", scienceLevel.mechEng.miscMod);
    printf("powrEng\n");
    printf("   diffLevel = %i\n", scienceLevel.powrEng.diffLevel);
    printf("   rankBonus = %i\n", scienceLevel.powrEng.rankBonus);
    printf("   miscMod = %i\n", scienceLevel.powrEng.miscMod);
    printf("weapEng\n");
    printf("   diffLevel = %i\n", scienceLevel.weapEng.diffLevel);
    printf("   rankBonus = %i\n", scienceLevel.weapEng.rankBonus);
    printf("   miscMod = %i\n", scienceLevel.weapEng.miscMod);
    printf("language = %i\n", language);
    printf("worship = %i\n", worship);
    printf("worshipExtension = %i\n", worshipExtension);
    printf("xenoAcceptance = %i\n", xenoAcceptance);
    printf("problems = %i\n", problems);
    printf("problemsExtension = %i\n", problemsExtension);

    return 0;
    }

CString Race::getDescription(int itemNum)
{
    CString descriptionC, descriptionE, descriptionM, descriptionP, descriptionW;
    CString description = "you suck so much";
    switch(itemNum)
        {
        case 0:     //Basic Type
            switch(basicType)
                {
                case 0: description = "Known humanoid race";
                    break;
                case 1: description = "Known transhuman or replicant race";
                    break;
                case 2: description = "Known alien race";
                    break;
                case 3: description = "Unknown humanoid race";
                    break;
                case 4: description = "Unknown transhuman or replicant race";
                    break;
                case 5: description = "Unknown mutation: add 16 special abilities to known race";
                    break;
                case 6: description = "Unknown hominoid variant/humananimal race";
                    break;
                case 7: description = "Unknown alien race";
                    break;
                case 8: description = "Unknown non-hydrocarbonbased race";
                    break;
                case 9: description = "Unknown/Advanced beyond needing physical bodies";
                    break;
                }
            break;
        case 1:     // Racial Origins
            switch(racialOrigins)
                {
                case 0: description = "Imperial colonists / secessionists / subjugates";
                    break;
                case 1: description = "Provincial colonists / secessionists / subjugates";
                    break;
                case 2: description = "Criminals / exiles / renegades";
                    break;
                case 3: description = "Secessionists from the Terran Federated Democracy";
                    break;
                case 4: description = "Cryo-sleep colonists (pre-recession)";
                    break;
                case 5: description = "Human / xeno-human interbreeding";
                    break;
                case 6: description = "Known alien race";
                    break;
                case 7: description = "Lesser lifeform on homeworld";
                    break;
                case 8: description = "Race of ancients";
                    break;
                case 9: description = "Unknown alien race";
                    break;
                }
            break;
        case 2:     // Kinship Structure
            switch(kinshipStructure)
                {
                case 0: description = "Mates only; young are born viable or raised in unusual style";
                    break;
                case 1: description = "Nuclear family";
                    if( kinshipStructureExtension < 5 ){
                        description += " (paternal)";
                        }
                    else if( kinshipStructureExtension < 9 ){
                        description += " (maternal)";
                        }
                    else description += " (both/other) ";
                    break;
                case 2: description = "Extended family";
                    if( kinshipStructureExtension < 4 ){
                        description += " (paternal)";
                        }
                    else if( kinshipStructureExtension < 8 ){
                        description += " (maternal)";
                        }
                    else description += " (both/other) ";
                    break;
                case 3: description = "Large commune";
                    if( kinshipStructureExtension < 5 ){
                        description += " (industrial / economic)";
                        }
                    else if( kinshipStructureExtension < 8 ){
                        description += " (religious)";
                        }
                    else description += " (other) ";
                    break;
                case 4: description = "Clubs / societies / guilds ( special interest groups )";
                    break;
                case 5: description = "Small communes / bands";
                    if( kinshipStructureExtension < 5 ){
                        description += " (industrial / economic)";
                        }
                    else if( kinshipStructureExtension < 8 ){
                        description += " (religious)";
                        }
                    else description += " (other) ";
                    break;
                case 6: description = "Mixed at least 2 levels of approx equal significance";
                    break;
                case 7: description = "2 Hemicultures (male / female; good / evil; etc)";
                    break;
                case 8: description = "Entire society (absolute socialism or hivemind); dont roll polit";
                    break;
                case 9: description = "Varies; absolute and/or independence";
                    break;
                }
            break;
        case 3:     // Values
            switch(values)
                {
                case 0: description = "Warfare / physical domination / genocide";
                    break;
                case 1: description = "Possession of land / planets / territory";
                    break;
                case 2: description = "Trade / profit / possession of valuable merchandise";
                    break;
                case 3: description = "Specific tech field / industry (production)";
                    break;
                case 4: description = "Specific scientific field (research and development)";
                    break;
                case 5: description = "Artistic expression / impression";
                    break;
                case 6: description = "Eclectic / erratic / diverse";
                    break;
                case 7: description = "Religion / philosophy";
                    break;
                case 8: description = "Distribution of information / resources / services";
                    break;
                case 9: description = "Beyond human understanding";
                    break;
                }
            break;
        case 4:     // Political Structure
            switch(politicalStructure)
                {
                case 0: description = "None; anarchy and chaos / collapsed governments\r\n / total opportunism";
                    break;
                case 1: description = "Theocracy";
                    break;
                case 2: description = "Dictatorship / monarchy / police state";
                    break;
                case 3: description = "Representative democracy";
                    break;
                case 4: description = "Republic / commonwealth";
                    break;
                case 5: description = "Feodality";
                    break;
                case 6: description = "Oligarchy";
                    if( politicalStructureExtension < 6 ){
                        description += " (land / labor)";
                        }
                    else if( politicalStructureExtension < 8 ){
                        description += " (theocrats)";
                        }
                    else description += " (other) ";
                    break;

                case 7: description = "Bureaucracy (multiple oligarchies)";
                    break;
                case 8: description = "Actual / Platonic democracy";
                    break;
                case 9: description = "Nil; anarchy and peace";
                    break;
                }
            break;
        case 5:     // Tech / Science Level
            descriptionC.Format("Computer Engineering\r\nDifficulty Level = %d     Rank Bonus = %d     Misc Modifier = %d\r\n", scienceLevel.compEng.diffLevel, scienceLevel.compEng.rankBonus, scienceLevel.compEng.miscMod);
            descriptionE.Format("Electrical Engineering\r\nDifficulty Level = %d     Rank Bonus = %d     Misc Modifier = %d\r\n", scienceLevel.elecEng.diffLevel, scienceLevel.elecEng.rankBonus, scienceLevel.elecEng.miscMod);
            descriptionM.Format("Mechanical Engineering\r\nDifficulty Level = %d     Rank Bonus = %d     Misc Modifier = %d\r\n", scienceLevel.mechEng.diffLevel, scienceLevel.mechEng.rankBonus, scienceLevel.mechEng.miscMod);
            descriptionP.Format("Power Engineering\r\nDifficulty Level = %d     Rank Bonus = %d     Misc Modifier = %d\r\n", scienceLevel.powrEng.diffLevel, scienceLevel.powrEng.rankBonus, scienceLevel.powrEng.miscMod);
            descriptionW.Format("Weapon Engineering\r\nDifficulty Level = %d     Rank Bonus = %d     Misc Modifier = %d\r\n", scienceLevel.weapEng.diffLevel, scienceLevel.weapEng.rankBonus, scienceLevel.weapEng.miscMod);
            description = descriptionC + "\r\n" + descriptionE + "\r\n" + descriptionM + "\r\n" + descriptionP + "\r\n" + descriptionW;
            break;
        case 6:     // Language
            switch(language)
                {
                case 0: description = "Anglaman (terran standard) or derivative";
                    break;
                case 1: description = "Dialect / derivative of old earth language (most provincial tongues)";
                    break;
                case 2: description = "Fusion of 2 or more old earth derivatives";
                    break;
                case 3: description = "Designed language";
                    break;
                case 4: description = "Highly specific on some topics; very ineffective on others";
                    break;
                case 5: description = "Extremely hard for most hominoids to speak (physically)";
                    break;
                case 6: description = "Sentence / concept structures are extremely hard for most hominoids";
                    break;
                case 7: description = "Silent language using double meanings and/or body movements";
                    break;
                case 8: description = "Constant or near constant communication via extraordinary means";
                    break;
                case 9: description = "Utilizes means of communication beyond normal human capabilities";
                    break;
                }
            break;
        case 7:     // Worship
            switch(worship)
                {
                case 0: description = "None; no real religious concept";
                    break;
                case 1: description = "Animism; most / all objects considered alive to some degree";
                    break;
                case 2: description = "Animism; all living beings considered to posses souls";
                    break;
                case 3: description = "Pantheon; group of deities, each the patron of some aspect";
                    break;
                case 4: description = "Bitheism; two diametrically opposed deities";
                    break;
                case 5: description = "Monotheism; all nature regarded as work of one god or creative force";
                    break;
                case 6: description = "Certain person";
                    if( worshipExtension < 7 ){
                        description += " (past)";
                        }
                    else if( worshipExtension < 9 ){
                        description += " (present)";
                        }
                    else description += " (future) ";
                    break;
                case 7: description = "Specific attainable states of being or consciousness";
                    break;
                case 8: description = "Each individual considered godhead";
                    break;
                case 9: description = "Beyond human understanding";
                    break;
                }
            break;
        case 8:     // Xeno Acceptance
            switch(xenoAcceptance)
                {
                case 0: description = "Sheer folly; total xenophobia (possibly due to past experiences)";
                    break;
                case 1: description = "Extremely hard; may have had bad experience with outsiders before";
                    break;
                case 2: description = "Very hard; cultural doctrine may include warnings against outsiders";
                    break;
                case 3: description = "Hard; cultural leanings toward isolationism";
                    break;
                case 4: description = "Medium; curiosity is balanced by caution or mild distrust";
                    break;
                case 5: description = "Light; very curious but somewhat wary of outsiders";
                    break;
                case 6: description = "Easy; some dealings with aliens / xenohumans have occured before";
                    break;
                case 7: description = "Routine; aliens and xenohumans dealt with on a regular basis";
                    break;
                case 8: description = "Easy if studying newly discovered race; otherwise very hard";
                    break;
                case 9: description = "Total; alien / xenohuman contact is actively sought";
                    break;
                }
            break;
        case 9:     // Problems
            switch(problems)
                {
                case 0: description = "Military / diplomatic clashes with neighboring race / province";
                    break;
                case 1: description = "Need resource(s)";
                    if( problemsExtension < 3 ){
                        description += " (food / water)";
                        }
                    else if( problemsExtension < 7 ){
                        description += " (fuel)";
                        }
                    else description += " (other) ";
                    break;
                case 2: description = "Pollution of homeworld territorial possession";
                    break;
                case 3: description = "Pestilence / plague / disease / lack of immunity / tolerance to microbes";
                    break;
                case 4: description = "Resist change, clinging to old ways / rituals / lifestyles";
                    break;
                case 5: description = "Have lost systems / planets / territory to neighboring race / province";
                    break;
                case 6: description = "Internal moral / ethical / religious differences cause friction";
                    break;
                case 7: description = "Idealistic view prevents true objectivity";
                    break;
                case 8: description = "Taken advantage of / oppressed / enslaved by other race / culture";
                    break;
                case 9: description = "Misunderstood / misrepresented by other races";
                    break;
                }
            break;
               
        }

    return description;
}


int main(int argc, char* argv[])
{
    myRace = new Race;

    Seed = 10;

    myRace->key = (unsigned)time( NULL );
    //star->key = Seed;  //Testing Remove
    srand(myRace->key);

    myRace->generate();
    myRace->printRace();
	return 0;
}

